import { CategoryBucketCalculator } from "./CategoryBucketCalculator";
import { Type } from "igniteui-react-core/ES5/type";
import { IFastItemColumn$1 } from "igniteui-react-core/ES5/IFastItemColumn$1";
import { CategorySeries } from "./CategorySeries";
import { IIsCategoryBased } from "./IIsCategoryBased";
import { IHasHighLowValueCategory } from "./IHasHighLowValueCategory";
import { RangeCategoryFramePreparer } from "./RangeCategoryFramePreparer";
import { CategoryMode } from "./CategoryMode";
import { ICategoryScaler } from "./ICategoryScaler";
import { IScaler } from "./IScaler";
import { IBucketizer } from "./IBucketizer";
import { CategorySeriesView } from "./CategorySeriesView";
import { CategoryFrame } from "./CategoryFrame";
import { SeriesView } from "./SeriesView";
import { CategoryTransitionInMode } from "./CategoryTransitionInMode";
import { List$1 } from "igniteui-react-core/ES5/List$1";
import { Polyline } from "igniteui-react-core/ES5/Polyline";
import { Polygon } from "igniteui-react-core/ES5/Polygon";
import { Rect } from "igniteui-react-core/ES5/Rect";
import { Axis } from "./Axis";
import { AxisRange } from "./AxisRange";
import { FastItemsSourceEventAction } from "igniteui-react-core/ES5/FastItemsSourceEventAction";
import { IDetectsCollisions } from "./IDetectsCollisions";
import { RenderSurface } from "./RenderSurface";
export declare class RangeCategoryBucketCalculator extends CategoryBucketCalculator {
    j: RangeCategorySeriesView;
    constructor(a: RangeCategorySeriesView);
    getBucketWithoutUnknowns(a: number): number[];
    getBucket(a: number): number[];
    private l;
    private k;
    private i;
    private h;
    cacheValues(): void;
    unCacheValues(): void;
    static $t: Type;
}
export declare abstract class RangeCategorySeries extends CategorySeries implements IIsCategoryBased, IHasHighLowValueCategory {
    protected bf(): SeriesView;
    ii(a: SeriesView): void;
    om: RangeCategorySeriesView;
    constructor();
    private _RangeFramePreparer;
    RangeFramePreparer: RangeCategoryFramePreparer;
    ov: string;
    lowColumn: IFastItemColumn$1<number>;
    private op;
    os: string;
    highColumn: IFastItemColumn$1<number>;
    private on;
    protected m4(): CategoryTransitionInMode;
    ob(a: CategoryFrame, b: CategorySeriesView): void;
    protected ox(a: Polyline, b: Polygon, c: Polyline, d: number, e: List$1<number[]>, f: boolean): void;
    c6(a: any): boolean;
    protected io(a: any, b: string, c: any, d: any): void;
    an(a: Axis): AxisRange;
    protected ho(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    dt(a: Rect, b: Rect, c: SeriesView): boolean;
    n8(a: CategoryFrame, b: CategorySeriesView): void;
    readonly currentCategoryMode: CategoryMode;
    readonly scaler: ICategoryScaler;
    readonly yScaler: IScaler;
    readonly bucketizer: IBucketizer;
    readonly currentMode2Index: number;
    provideCollisionDetector(): IDetectsCollisions;
    readonly mayContainUnknowns: boolean;
    i3(a: Rect, b: RenderSurface): void;
    private ok;
    i0(a: Rect, b: Rect, c: RenderSurface, d: string, e: number): void;
    ec(): number;
    readonly useHighMarkerFidelity: boolean;
    static $$p: string[];
    static $t: Type;
}
export declare class RangeCategorySeriesView extends CategorySeriesView {
    cu: RangeCategorySeries;
    constructor(a: RangeCategorySeries);
    cv(a: Polyline, b: Polygon, c: Polyline, d: number, e: List$1<number[]>, f: boolean): void;
    cm(): CategoryBucketCalculator;
    static $t: Type;
}
